package net.ihe.gazelle.business.provider;

import ca.uhn.fhir.rest.annotation.IdParam;
import ca.uhn.fhir.rest.annotation.ResourceParam;
import ca.uhn.fhir.rest.api.MethodOutcome;
import ca.uhn.fhir.rest.server.exceptions.InternalErrorException;
import ca.uhn.fhir.rest.server.exceptions.InvalidRequestException;
import net.ihe.gazelle.application.PatientRegistryFeedClient;
import org.hl7.fhir.instance.model.api.IIdType;
import org.hl7.fhir.r4.model.IdType;
import org.hl7.fhir.r4.model.Patient;

public class CHPatientProviderMock extends ChPatientResourceProvider {


    public CHPatientProviderMock(PatientRegistryFeedClient patientRegistryFeedClient) {
        super(patientRegistryFeedClient);

    }

    @Override
    public MethodOutcome create(@ResourceParam Patient iti93Patient) {
        MethodOutcome mo = new MethodOutcome();
        IIdType iIdType = new IdType();

        //Case OK
        if (iti93Patient.getId().equals("Patient/PatientPIXmFeed")) {
            return mo.setId(iIdType.setValue("OK"));
        }
        //Case KO
        if (iti93Patient.getId().equals("Bundle/PatientPIXmFeed")) {
            return null;
        }
        //Case NULL
        if (iti93Patient == null) {
            return null;
        }
        return null;
    }

    @Override
    public MethodOutcome delete(@ResourceParam IdType id) {
        MethodOutcome mo = new MethodOutcome();
        IdType iIdType = new IdType();

        //Case OK
        if (id.equals(CHBundleProviderTest.GOOD_UUID)) {
            return mo.setId(iIdType.setValue("OK"));
        }

        return null;
    }

    @Override
    public MethodOutcome update(@IdParam IdType theId, @ResourceParam Patient hl7Patient) {
        MethodOutcome mo = new MethodOutcome();
        IdType iIdType = new IdType();

        //Case OK

        if (theId.equals(CHBundleProviderTest.GOOD_UUID)) {
            return mo.setId(iIdType.setValue("OK"));
        } else if (theId.equals(CHBundleProviderTest.Throw_ID)) {
            throw new InvalidRequestException("");
        } else if (theId.equals(CHBundleProviderTest.Throw_two_id)) {
            throw new InternalErrorException("");
        }

        return null;
    }
}
