package net.ihe.gazelle.business.provider;

import java.util.ArrayList;
import java.util.List;

import org.hl7.fhir.r4.model.Patient;

import net.ihe.gazelle.app.patientregistrysearchclient.adapter.PatientSearchClient;
import net.ihe.gazelle.application.PatientRegistrySearchClient;
import net.ihe.gazelle.framework.preferencesmodelapi.application.OperationalPreferencesService;
import net.ihe.gazelle.lib.searchmodelapi.business.exception.SearchException;

public class PatientRegistrySearchClientMock extends PatientRegistrySearchClient {
	public static final String HTTP_OK = "HTTP_OK";
	public static final String URN_OK = "URN_OK";
	private static final String CROSS_REFERENCE = "Cross Reference";

	public PatientRegistrySearchClientMock() {
	}

	public PatientRegistrySearchClientMock(OperationalPreferencesService operationalPreferencesService) {
		super(operationalPreferencesService);
	}

	public PatientRegistrySearchClientMock(PatientSearchClient searchClient) {
		setClient(searchClient);
	}
	@Override
	public Patient searchPatient(String uuid) throws SearchException {

		Patient arthur = new Patient();
		arthur.addName().addGiven("Arthur");

		switch (uuid){
		case "1":
			throw new SearchException("test exception");
		case "3":
			return arthur;
		default:
			return null;
		}
	}
}
